//    
// (    -   )
//   
//    

#include<stdio.h>
#include<string.h>
#include<malloc.h>
#include<stdlib.h>


char str1[]="|||||||1924373814712 WILDER WEIN - VOR DIESEM DUNKEL"; //  
#define SIZE (sizeof(str1)-1)

char buff[SIZE+1];

#define PATH_LEFT	1 //  (    
#define PATH_UP		2
#define PATH_DIG	3

int matrix[SIZE+1][SIZE+1]; //  
int path  [SIZE+1][SIZE+1]; //  

void Output(int x,int y) //  
{
	int n;
	while(x>=0 && y>=0) 
	{
		switch(path[x][y]) {
		case PATH_LEFT: buff[x]=0;x--; break;
		case PATH_UP: y--;  break;
		case PATH_DIG: x--; y--; break;
	}
	}
	while(x>=0) buff[x--]=0;
	for(n=0; str1[n]; n++) putchar(buff[n]?'+':'-');  //if(!buff[n]) putchar(str1[n]); 
	printf("\n%s\n",str1);
	putchar('\n');
}


void StringInit()
{
	int n,m; char sym;
	strcpy(buff,str1);
	for(n=0; n<SIZE; n++) for(m=n+1; m<SIZE; m++) if(buff[n]>buff[m]) sym=buff[n],buff[n]=buff[m],buff[m]=sym;
}


char res[SIZE+1]; int max;
void TestSub(int pos,int depth)
{
	int n; int left,old;
	left=pos<0?-256:str1[pos]; old=-1;
//	if(pos-depth+max>len) return;
	for(n=pos+1; str1[n]; n++) {
		if(str1[n]==old) continue; old=str1[n];
		if(str1[n]<left) continue;
		buff[n]='+';
		TestSub(n,depth+1);
		buff[n]='-';
	}
	if(depth>max) max=depth,strcpy(res,buff);
}

//   ( )
void Test()
{
	int n;
	for(n=0; str1[n]; n++) buff[n]='-'; buff[n]=0;
	max=-1; TestSub(-1,0);
	printf("%s\n%s\n",str1,res);
}




void main()
{
	int x,y,l,u,lu,n; char sym;
	printf("size: %d\n",SIZE);
	StringInit();
	for(y=0; y<SIZE; y++)  //   
	for(x=0; x<SIZE; x++) {
		if(x || y)
		{ 
			if(x && y) lu=matrix[x-1][y-1]; 
			if(x) l=matrix[x-1][y]; else l=y+1,lu=0;
			if(y) u=matrix[x][y-1]; else u=x+1,lu=0;
		} else l=u=lu=0;
		if(u>l) l=u,n=PATH_UP; else n=PATH_LEFT;
		if(str1[x]==buff[y]) l=lu+1,n=PATH_DIG; 
		matrix[x][y]=l;
		path[x][y]=n;
	}
//   
	printf("\n[path]\n");
	for(y=0; y<SIZE; y++) {
		for(x=0; x<SIZE; x++) switch(path[x][y]) {
			case PATH_UP:   putchar('u'); break;
			case PATH_LEFT: putchar('l'); break;
			case PATH_DIG:  putchar('d'); break;
			default: putchar('?'); break;
		}
		putchar('\n');
	}
//   
	printf("\n[matrix]\n");
	printf("   %s\n",str1);
	for(y=0; y<SIZE; y++) {
		printf("%c: ",buff[y]);
		for(x=0; x<SIZE; x++) {
			sym=matrix[x][y];
			putchar(sym<0?'-':sym<10?sym+'0':sym+'A'-10);
		}
		putchar('\n');
	}
//   
	printf("\n[result]\n");
	Output(SIZE-1,SIZE-1); 
	printf("\nPress enter...\n");
	getchar();
}



